class LSystem {
String axiom;
String computedWord;
String[][] koch = {{"F", "F-F++F-F"}}; 
String[][] square = {{"F", "F-FF--F-F"}};
String[][] rules = {{"L", "L+R+"}, 
                    {"R", "-L-R"},
                    {"+", "+"}, 
                    {"-", "-"}};
String[][] tree = {
                   {"+", "+", "+", "+"}, 
                   {"-", "-", "-", "-"}, 
                   {"[", "[", "[", "["}, 
                   {"]", "]", "]", "]"},
                   {"X", "F-[[X]+X]+F[+[FX]-X]", "FX[[X]+F+X]-X[+FX]", "F[-X][+X]F+[X]-X-X"}, 
                   {"F", "FF", "FF", "FF"},
                  };
float size, angle;
LSystem(float size, float angle) { 
  this.size = size;
  this.angle = angle;
  axiom = "X";
  computedWord = axiom; 
}

void iterate (int iterations) {
  String tempWord;
  println("starting word: " +computedWord); 
  for(int i=0; i<iterations; i++) {
    tempWord = computedWord; 
    computedWord = "";
    for(int j=0; j<tempWord.length(); j++) { 
      char c = tempWord.charAt(j);
      for(int k=0; k<tree.length;k++) {
        if (c==tree[k][0].charAt(0)) { 
          computedWord = computedWord + tree[k][(int)random(1,3)]; 
          break;
          }
        }
      }
    println("iteration " + i +": " +computedWord);
    }
  }
  
void drawLSystem(Turtle t) {
  char c;
  int orientation = 0;
  for (int i=0; i<computedWord.length(); i++) { 
    c = computedWord.charAt(i);
    if (c == 'F')
      t.forward(size);
    else if (c == '+') {
      t.right(angle);
      orientation = 1;
    }
    else if (c == '-') {
      t.left(angle);
      orientation = 2;
    }
     else if (c == 'L') 
      t.forward(size);
     else if (c == 'R') 
      t.forward(size);
      else if (c == '[') 
      t.push();
     else if (c == ']') 
      t.pop();
     else if (c == 'X') {
       drawLeaf(orientation);
     }
    }
  }

void drawLeaf(int orientation) {
  noStroke();
  if (orientation == 1) {
    fill(0,255,0);
    arc(t.getX(), t.getY(), 2*size, 2*size, PI, PI+QUARTER_PI);
  }
  else if (orientation == 2) {
    fill(199, 242, 56);
    arc(t.getX(), t.getY(), 2*size, 2*size, PI+HALF_PI, PI+HALF_PI+QUARTER_PI);
  }
  noFill();
  stroke(82, 53, 33);
}
 
}
