class LSystem {
String axiom;
String computedWord;
String[][] tree = {
                   {"+", "+", "+", "+"}, 
                   {"-", "-", "-", "-"}, 
                   {"[", "[", "[", "["}, 
                   {"]", "]", "]", "]"},
                   {"L", "L", "L", "L"},
                   {"X", "F-[X]+XF[+[FLX]-X]", "F[X]+[X[X]]-X", "F+[X]-[[FX]+X]LX"}, 
                   {"F", "FF", "FF", "FF"},
                  };
float size, angle;
LSystem(float size, float angle) { 
  this.size = size;
  this.angle = angle;
  axiom = "X";
  computedWord = axiom; 
}

void iterate (int iterations) {
  String tempWord;
  println("starting word: " +computedWord); 
  for(int i=0; i<iterations; i++) {
    tempWord = computedWord; 
    computedWord = "";
    for(int j=0; j<tempWord.length(); j++) { 
      char c = tempWord.charAt(j);
      for(int k=0; k<tree.length;k++) {
        if (c==tree[k][0].charAt(0)) { 
          computedWord = computedWord + tree[k][(int)random(1,3)]; 
          break;
          }
        }
      }
    println("iteration " + i +": " +computedWord);
    }
  }
  
void drawLSystem(Turtle t) {
  char c;
  int orientation = 0;
  for (int i=0; i<computedWord.length(); i++) { 
    c = computedWord.charAt(i);
    if (c == 'F')
      t.forward(size);
    else if (c == '+') {
      t.right(angle);
      orientation = 1;
    }
    else if (c == '-') {
      t.left(angle);
      orientation = 2;
    }
     else if (c == 'L'){ 
      orientation = 3;
     }
     else if (c == 'R') 
      t.forward(size);
      else if (c == '[') 
      t.push();
     else if (c == ']') 
      t.pop();
     else if (c == 'X') {
       drawLeaf(orientation);
     }
    }
  }

void drawLeaf(int orientation) {
  
  noStroke();
  if (orientation == 2) {
    fill(0,255,0);
    leaf();
  }
  else if (orientation == 1) {
    fill(245, 66, 242);
    drawFlower();
  }
  else if (orientation == 3) {
    fill(255, 0, 0);
    ellipse(t.getX(), t.getY(), 2*size, 2*size);
  }
  noFill();
  stroke(82, 53, 33);
}
  void leaf() {
    arc(t.getX(), t.getY(), 6*size, 6*size, PI+HALF_PI, PI+HALF_PI+QUARTER_PI);
    arc(t.getX(), t.getY(), 6*size, 6*size, PI, PI+QUARTER_PI);
    
  }
  
  void drawFlower() {
    arc(t.getX(), t.getY(), 3*size, 3*size, PI+HALF_PI, PI+HALF_PI+QUARTER_PI);
    arc(t.getX(), t.getY(), 3*size, 3*size, PI, PI+QUARTER_PI);
    arc(t.getX(), t.getY(), 3*size, 3*size, 0, 0+QUARTER_PI);
    arc(t.getX(), t.getY(), 3*size, 3*size, 0+HALF_PI, 0+HALF_PI+QUARTER_PI);
    fill(255, 250, 0);
    ellipse(t.getX(), t.getY(), size, size);
  } 
}
